"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var material_1 = require("@mui/material");
var isEmpty_1 = __importDefault(require("lodash/isEmpty"));
var kebabCase_1 = __importDefault(require("lodash/kebabCase"));
var react_1 = __importDefault(require("react"));
var style = {
    height: '1.1875rem',
};
var getType = function (type) {
    return (0, isEmpty_1.default)(type) ? 'text' : type;
};
var getLabel = function (id, label, inputLabelProps) {
    if ((0, isEmpty_1.default)(label)) {
        return null;
    }
    if (inputLabelProps === undefined) {
        inputLabelProps = {};
    }
    return (react_1.default.createElement(material_1.InputLabel, __assign({}, inputLabelProps, { htmlFor: id }), label));
};
var getHelperText = function (helperText, helperTextProps) {
    if ((0, isEmpty_1.default)(helperText)) {
        return null;
    }
    if (helperTextProps === undefined) {
        helperTextProps = {};
    }
    return react_1.default.createElement(material_1.FormHelperText, __assign({}, helperTextProps), helperText);
};
var InputField = function (props) {
    var inputProps = props.inputProps
        ? props.inputProps
        : {
            inputProps: {},
        };
    return (react_1.default.createElement(material_1.FormControl, { fullWidth: true },
        getLabel(props.id, props.label, props.inputLabelProps),
        react_1.default.createElement(material_1.Input, __assign({}, inputProps, { id: props.id, inputProps: __assign(__assign({}, inputProps.inputProps), { style: style }), type: getType(props.type), placeholder: props.placeholder, value: props.value, name: (0, kebabCase_1.default)(props.id || props.label || props.placeholder), onFocus: props.onGotFocus, onBlur: props.onLostFocus, onChange: props.onChange, startAdornment: props.startAdornment, endAdornment: props.endAdornment })),
        getHelperText(props.helperText, props.helperTextProps)));
};
exports.default = InputField;
